//Codec for this file is Windows-1251
//   - Windows-1251

#include "DllHandler.h"


int DllHandler::valid_handles_count = 0; //. . 

DllHandler::DllHandler(const char* dllName) {
    hDLL = LoadLibraryA(dllName);
    if (hDLL)
        ++valid_handles_count;
}

DllHandler::DllHandler(const wchar_t* dllName) {
    hDLL = LoadLibraryW(dllName);
    if (hDLL)
        ++valid_handles_count;
}

FARPROC DllHandler::receive(const char* fun_name) {
    if (hDLL)
        return GetProcAddress(hDLL, fun_name);//NULL  
    return NULL;
}

void DllHandler::freeDll() {
    if (hDLL)
        if ( FreeLibrary(hDLL) ) {
            hDLL = NULL;
            --valid_handles_count;
        }
}

bool DllHandler::hasHandle() {
    return hDLL;
}
