//Codec for this file is UTF-8
//Кодировка этого исходника - UTF-8

//Тест класса DllHandler

#include <cstdio>
#include <clocale>
#include "../DllHandler/DllHandler.h"


typedef void (__stdcall* PFun1)(LPMEMORYSTATUS);
//Для GlobalMemoryStatus()
//http://msdn.microsoft.com/en-us/library/windows/desktop/aa366586(v=vs.85).aspx

typedef BOOL (__stdcall* PFun2)(WCHAR *, DWORD *);
//Для GetDefaultPrinterW()


int main() {

    //устанавливаем локаль для русского
    if (setlocale(LC_ALL, "Russian_Russia.1251")) {
        wprintf(L"Локаль установлена\n\n");
     } else wprintf(L"Error: Can't set Russian!\n\n");



    //(1) Простейший способ использования ------------------------------------------

    //Следующие две строки кода не вызовут фатальных сбоев при ошибке.
    DllHandler libKernel32("kernel32");
    PFun1 p_gms = (PFun1)libKernel32.receive("GlobalMemoryStatus");

    //Единственный принципиальный момент - убедиться, что ф-ция реально
    //получена (указатель отличен от NULL). Иначе фатальная ошибка при
    //обращении к ф-ции.
    if (p_gms) {
        //используем ф-цию
        MEMORYSTATUS ms;
        p_gms(&ms);
        wprintf(L"Использовано ОЗУ: %lu %%\n", ms.dwMemoryLoad);
    } else wprintf(L"Ошибка получения ф-ции или подключения библиотеки\n");

    wprintf(L"\n");


//(2) Динамическое использование -----------------------------------------------

    DllHandler *libKernel32_ptr = new DllHandler("kernel32");
    PFun1 p_gms2 = (PFun1)libKernel32_ptr->receive("GlobalMemoryStatus");
    if (p_gms2) {
        //используем ф-цию
        MEMORYSTATUS ms;
        p_gms2(&ms);
        wprintf(L"Использовано ОЗУ: %lu %%\n", ms.dwMemoryLoad);
    } else wprintf(L"Ошибка получения ф-ции или подключения библиотеки\n");
    delete libKernel32_ptr; //удаляем

    printf("\n");


//(3) С другой библиотекой (.drv) и unicode для разнообразия--------------------

    DllHandler none(L"несуществующая.dll");//имя dll в unicode
    //ЗАМЕТКА: для русских имен в юникод сам исходник нужно делать в UTF-8
    if (!none.hasHandle())
        wprintf(L"Ошибка подключения (преднамеренная)\n\n");

    DllHandler libWinspool(L"winspool.drv"); //имя dll в unicode
    if (libWinspool.hasHandle()) { //эта проверка не принципиальна, полезна
        //только для локализации места, где возникли проблемы
        PFun2 p_dp = (PFun2)libWinspool.receive("GetDefaultPrinterW");
        //unicode вариант API ф-ции GetDefaultPrinter()
        if (p_dp) { //принципиально важно проверить
            WCHAR defPr[500];
            DWORD len = sizeof(defPr)/sizeof(defPr[0]);
            if (p_dp(defPr, &len))
                wprintf(L"Принтер по-умолчанию: %s \n", defPr);
            else wprintf(L"Ошибка при обращении к ф-ции\n");
        } else wprintf(L"Ошибка получения ф-ции\n");
    } else wprintf(L"Ошибка подключения библиотеки\n");

    wprintf(L"\n");

//(4) Работа метода класса validHandlesCount()-------------------------------

    //если все нормально то сейчас подключено 2 библ.
    wprintf(L"Сейчас подключений к биб.: %d \n", DllHandler::validHandlesCount());
    wprintf(L"(если все нормально, должно быть 2)\n");

    const int num = 5;
    DllHandler *p[num];

    for (int i = 0; i < num; ++i)
        p[i] = new DllHandler("kernel32");
    wprintf(L"После создания %d DllHandler подключений к биб.: %d\n", num,
            DllHandler::validHandlesCount());

    for (int i = 0; i < num; ++i)
        delete p[i];
    wprintf(L"После уничтожения %d DllHandler подключений к биб.: %d\n", num,
            DllHandler::validHandlesCount());
    wprintf(L"(если все нормально, должно быть 2)\n");

    //оставшиеся библиотеки должны выгрузиться при окончании программы автоматически.
    //Но, здесь мы освободим их вручную и проверим:
    libWinspool.freeDll();
    libKernel32.freeDll();
    wprintf(L"После освобождения последних биб.: %d подключений.\n",
            DllHandler::validHandlesCount());

    wprintf(L"\nНажмите клавишу..");
    getchar();

    return 0;
}
